package csa

import (
	"git.sr.ht/~mil/mobroute/dbt"
)

// Transfers are a two-way operation so a transfer a-b also validates
// b-a. The returned datastructured is indexed as fromstop[tostop]uint
// which is the
// dbt.Transfer holds the
func buildTransfersMap(transfers *[]dbt.Transfer) map[string]map[string]uint {
	r := map[string]map[string]uint{}
	for i, _ := range *transfers {
		if _, exists := r[(*transfers)[i].FromStopParentUID]; !exists {
			r[(*transfers)[i].FromStopParentUID] = map[string]uint{}
		}
		if _, exists := r[(*transfers)[i].ToStopParentUID]; !exists {
			r[(*transfers)[i].ToStopParentUID] = map[string]uint{}
		}
		r[(*transfers)[i].FromStopParentUID][(*transfers)[i].ToStopParentUID] = (*transfers)[i].TransferSeconds
		r[(*transfers)[i].ToStopParentUID][(*transfers)[i].FromStopParentUID] = (*transfers)[i].TransferSeconds
	}
	return r
}

func InitializeMapStopToArrivalDetails(initialStopToArrivalTimeMap map[string]int) map[string]ArrivalDetails {
	r := map[string]ArrivalDetails{}
	for stop, arrivalTime := range initialStopToArrivalTimeMap {
		r[stop] = ArrivalDetails{
			Time:       arrivalTime,
			Connection: nil,
		}
	}
	return r
}

func ConnOIDs(conns []*dbt.Connection) []int {
	r := []int{}
	for _, c := range conns {
		r = append(r, c.ConnOID)
	}
	return r
}

func roundUp(value, roundToMultiple uint) uint {
	return (value + roundToMultiple - 1) / roundToMultiple * roundToMultiple
}
