package csa_test

import (
	th "git.sr.ht/~mil/mobroute/csa_test/csa_testhelper"
	"git.sr.ht/~mil/mobroute/dbt"
)

var csaTestCaseNegstarttime = CSATestCase{
	Test: "Negative Starttime: Supports negative from time values",
	Args: CSAArgs{
		Connections: th.ReorderByDepartureTime([]dbt.Connection{
			{ConnOID: 1_0, TripID: "1", FromStopUID: "a", ToStopUID: "b", FromST: -10, ToST: -3},
			{ConnOID: 1_1, TripID: "1", FromStopUID: "b", ToStopUID: "c", FromST: -3, ToST: 20},

			// Not taken ever since before FromTime of -11
			{ConnOID: 2_0, TripID: "2", FromStopUID: "a", ToStopUID: "d", FromST: -12, ToST: 20},
			{ConnOID: 2_1, TripID: "2", FromStopUID: "d", ToStopUID: "e", FromST: 20, ToST: 22},
		}),
		Transfers: &[]dbt.Transfer{},
		WalkcostsOrigin: map[string]uint{
			"a": 0, "b": 999, "c": 999, "d": 999, "e": 999,
		},
		FromTime:           -11,
		MaxTransferSeconds: 3,
		MaxNTransfers:      99,
	},
	Expect: map[string]CSATestArrivalDetails{
		"a": {-11, th.NA, 0},
		"b": {-3, 1_0, 1},
		"c": {20, 1_1, 1},
		"d": {988, th.NA, 0},
		"e": {988, th.NA, 0},
	},
}
