package csa_test

import (
	th "git.sr.ht/~mil/mobroute/csa_test/csa_testhelper"
	"git.sr.ht/~mil/mobroute/dbt"
)

var csaTestCaseTransfersImplicit = CSATestCase{
	Test: "transfers_implicit: Handles implicit transfers case accounting for transfer seconds (doesn't take 3_0 or 4_0; takes 5_0)",
	Args: CSAArgs{
		Connections: th.ReorderByDepartureTime([]dbt.Connection{
			{ConnOID: 1_0, TripID: "1", FromStopUID: "a", ToStopUID: "b", FromST: 3, ToST: 10},
			{ConnOID: 1_1, TripID: "1", FromStopUID: "b", ToStopUID: "c", FromST: 10, ToST: 20},

			{ConnOID: 2_0, TripID: "2", FromStopUID: "a", ToStopUID: "d", FromST: 0, ToST: 1},
			{ConnOID: 2_1, TripID: "2", FromStopUID: "d", ToStopUID: "e", FromST: 1, ToST: 2},

			{ConnOID: 3_0, TripID: "3", FromStopUID: "b", ToStopUID: "f", FromST: 10, ToST: 14},

			{ConnOID: 4_0, TripID: "4", FromStopUID: "b", ToStopUID: "f", FromST: 11, ToST: 14},

			{ConnOID: 5_0, TripID: "5", FromStopUID: "b", ToStopUID: "f", FromST: 12, ToST: 15},
		}),
		Transfers: &[]dbt.Transfer{
			{FromStopParentUID: "b", ToStopParentUID: "b", TransferSeconds: 1},
		},
		WalkcostsOrigin: map[string]uint{
			"a": 0, "b": 999, "c": 999, "d": 999, "e": 999, "f": 999,
		},
		FromTime:           1,
		MaxTransferSeconds: 7,
		MaxNTransfers:      99,
	},
	Expect: map[string]CSATestArrivalDetails{
		"a": {1, th.NA, 0},
		"b": {10, 1_0, 1},
		"c": {20, 1_1, 1},
		"d": {1000, th.NA, 0},
		"e": {1000, th.NA, 0},
		"f": {15, 5_0, 2},
	},
}
