package csa_test

import (
	th "git.sr.ht/~mil/mobroute/csa_test/csa_testhelper"
	"git.sr.ht/~mil/mobroute/dbt"
)

var csaTestCaseTransfersNop = CSATestCase{
	Test: "transfers_nop: Handles explicit transfers account for max transfer seconds (doesn't take 4_0/4_1)",
	Args: CSAArgs{
		Connections: th.ReorderByDepartureTime([]dbt.Connection{
			{ConnOID: 1_0, TripID: "1", FromStopUID: "a", ToStopUID: "b", FromST: 3, ToST: 10},
			{ConnOID: 1_1, TripID: "1", FromStopUID: "b", ToStopUID: "c", FromST: 10, ToST: 20},

			{ConnOID: 3_0, TripID: "3", FromStopUID: "g", ToStopUID: "h", FromST: 10, ToST: 12},
			{ConnOID: 3_1, TripID: "3", FromStopUID: "h", ToStopUID: "f", FromST: 12, ToST: 16},

			{ConnOID: 4_0, TripID: "4", FromStopUID: "g", ToStopUID: "h", FromST: 12, ToST: 13},
			{ConnOID: 4_1, TripID: "4", FromStopUID: "h", ToStopUID: "f", FromST: 17, ToST: 20},

			{ConnOID: 5_0, TripID: "5", FromStopUID: "g", ToStopUID: "f", FromST: 18, ToST: 19},
		}),
		Transfers: &[]dbt.Transfer{
			{FromStopParentUID: "b", ToStopParentUID: "g", TransferSeconds: 4},
		},
		WalkcostsOrigin: map[string]uint{
			"a": 0, "b": 999, "c": 999, "d": 999, "e": 999, "f": 999, "g": 999, "h": 999,
		},
		FromTime:           1,
		MaxTransferSeconds: 10,
		MaxNTransfers:      99,
	},
	Expect: map[string]CSATestArrivalDetails{
		"a": {1, th.NA, 0},
		"b": {10, 1_0, 1},
		"c": {20, 1_1, 1},
		"d": {1000, th.NA, 0},
		"e": {1000, th.NA, 0},
		"f": {19, 5_0, 2},
		"g": {14, 1_0, 1},
		"h": {1000, th.NA, 0},
	},
}
