package csa_test

import (
	th "git.sr.ht/~mil/mobroute/csa_test/csa_testhelper"
	"git.sr.ht/~mil/mobroute/dbt"
)

var csaTestCaseTransfersOk = CSATestCase{
	Test: "transfers_ok: Handles transfers accounting for transfer costs (takes 4_0/4_1)",
	Args: CSAArgs{
		Connections: th.ReorderByDepartureTime([]dbt.Connection{
			{ConnOID: 1_0, TripID: "1", FromStopUID: "a", ToStopUID: "b", FromST: 3, ToST: 10},
			{ConnOID: 1_1, TripID: "1", FromStopUID: "b", ToStopUID: "c", FromST: 10, ToST: 20},

			{ConnOID: 2_0, TripID: "2", FromStopUID: "a", ToStopUID: "d", FromST: 0, ToST: 1},
			{ConnOID: 2_1, TripID: "2", FromStopUID: "d", ToStopUID: "e", FromST: 1, ToST: 2},
			{ConnOID: 2_2, TripID: "2", FromStopUID: "e", ToStopUID: "f", FromST: 3, ToST: 4},
			{ConnOID: 2_3, TripID: "2", FromStopUID: "f", ToStopUID: "c", FromST: 5, ToST: 6},

			{ConnOID: 3_0, TripID: "3", FromStopUID: "g", ToStopUID: "h", FromST: 10, ToST: 12},
			{ConnOID: 3_1, TripID: "3", FromStopUID: "h", ToStopUID: "f", FromST: 12, ToST: 16},

			{ConnOID: 4_0, TripID: "4", FromStopUID: "g", ToStopUID: "h", FromST: 12, ToST: 13},
			{ConnOID: 4_1, TripID: "4", FromStopUID: "h", ToStopUID: "f", FromST: 17, ToST: 20},
		}),
		Transfers: &[]dbt.Transfer{
			{FromStopParentUID: "b", ToStopParentUID: "g", TransferSeconds: 1},
		},
		WalkcostsOrigin: map[string]uint{
			"a": 0, "b": 999, "c": 999, "d": 999, "e": 999, "f": 999, "g": 999, "h": 999,
		},
		FromTime:           1,
		MaxTransferSeconds: 7,
		MaxNTransfers:      99,
	},
	Expect: map[string]CSATestArrivalDetails{
		"a": {1, th.NA, 0},
		"b": {10, 1_0, 1},
		"c": {20, 1_1, 1},
		"d": {1000, th.NA, 0},
		"e": {1000, th.NA, 0},
		"f": {20, 4_1, 2},
		"g": {11, 1_0, 1},
		"h": {13, 4_0, 2},
	},
}
