#!/usr/bin/env sh
cd "$(realpath "$(dirname "$0")")"/.. || exit 1

# E.g. used to generate CLI doc:
# ./generate_cliguide.sh > doc/userguide_cli.md

HEADER="$(cat <<EOF
# **Mobroute:** CLI Documentation

EOF
)"

FOOTER="$(cat <<EOF
EOF
)"

gendoc() {
  SUBCMD=$1
  ./build.sh run $SUBCMD 2>&1
}

mddoc() {
  echo "$HEADER"
  echo "The following CLI documentation is automatically generated from using the \`-h\` flag on each \`mobroute\` subcommand. These docs provide a good comprehensive high-level overview of functionality for each CLI subcommand. If you are looking for a more step-like tutorial / guide to using mobroute's CLI; please see also the [userguide](userguide_cli.md)."
  echo ""

  echo '## **Mobroute CLI: usage**'
  echo '```'
  gendoc usage
  echo '```'
  echo ''

  echo '## **Mobroute CLI: database**'
  echo '```'
  gendoc database
  echo '```'
  echo ''

  echo '## **Mobroute CLI: databaseq**'
  echo '```'
  gendoc databaseq
  echo '```'
  echo ''

  echo '## **Mobroute CLI: route**'
  echo '```'
  gendoc route
  echo '```'
  echo ''

  echo '## **Mobroute CLI: stops**'
  echo '```'
  gendoc stops
  echo '```'
  echo ''

  echo '## **Mobroute CLI: schedule**'
  echo '```'
  gendoc schedule
  echo '```'
  echo ''

  echo "$FOOTER"
}

mddoc
